import {EncodedPayload} from './types'

/**
 * Wrapper class for managing values encoded in a string format.
 */
export class Payload<T> {
    /** Instantiate the payload from a given string. */
    public static from<T>(v: EncodedPayload<T>): Payload<T> {
        const encoded = v.slice('multicrypt:'.length)
        return new Payload<T>(JSON.parse(encoded))
    }

    /** Instantiate the payload from a given value. */
    constructor(
        public readonly value: T,
    ) {}

    /** Serialize the value. */
    encode(): EncodedPayload<T> {
        return `multicrypt:${JSON.stringify(this.value)}`
    }
}
